VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CIDAScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
  Option Explicit
'still some 'todo x64

Public ipc As CIpc
Attribute ipc.VB_VarHelpID = -1
Private tmp_x As New ULong64
Private m_is64BitMode As Boolean 'this gets out of sync if they change ipc remote...
Private m_lastServer As Long
Private pe As CPEEditor

Property Get is64BitMode() As Boolean

    If m_lastServer <> ipc.RemoteHWND Then
        m_lastServer = ipc.RemoteHWND
        m_is64BitMode = (Me.bits = 64)
    End If
    
    is64BitMode = m_is64BitMode
        
End Property

Function getRes(optPath)
    On Error GoTo hell
    Dim r As CResData
    Dim tmp() As String, i As Long
    Dim u As New vbUTypes.ULong64
    
    Set pe = New CPEEditor
    If Len(optPath) = 0 Then optPath = loadedFile 'easier for testing if we can specify..
    
    If Not pe.LoadFile(expandPath(optPath)) Then GoTo hell
    
    push tmp, "["
    For Each r In pe.Resources.entries 'note json does not support hex numbers?!
        
        i = i + 1
        u.value = r.OffsetToDataRVA
        Set u = pe.RVAtoVA(u)  'has to be returned as string because js doesnt handle x64 either...
        
        push tmp, "    {'path' : '" & Replace(r.path, "\", "\\") & _
                        "', 'foff': " & pe.RvaToOffset(r.OffsetToDataRVA) & _
                        ", 'va': '0x" & u.toString(mHex) & "'" & _
                        ", 'size': " & r.Size & _
                        "}" & _
                        IIf(i = pe.Resources.entries.count, "", ",")
    Next
    push tmp, "]"
    
    getRes = Join(tmp, vbCrLf)
    Exit Function
    
hell:
    getRes = "[]" 'empty json array
    
End Function


'todo: crypt.getBin does same thing..remove this?
Function loadToJS(fpath)
    
    On Error GoTo hell
    Dim f As Long, b As Byte, tmp() As String, t As String
    
    f = FreeFile
    Open expandPath(fpath) For Binary As f
    
    While Not EOF(f)
        Get f, , b
        t = t & "\x" & Right("0" & Hex(b), 2)
        If Len(t) > 500 Then
            push tmp, t
            t = Empty
        End If
    Wend
    
    If Len(t) > 0 Then push tmp, t
    
hell:
    On Error Resume Next
    Close f
    loadToJS = Join(tmp, "")
    
End Function

'todo: not working with x64
Function OffsetToVa(offset)
    Dim a, b
    a = x64IntToHex(offset)
    OffsetToVa = x64IntToHex(ipc.SendCmdRecvText("offtova:" & a & ":" & ipc.listenHwnd))
End Function

'todo: not working with x64
Function VaToOffset(va)
    
    Dim a, b
    a = x64IntToHex(va)
    VaToOffset = x64IntToHex(ipc.SendCmdRecvText("vatooff:" & a & ":" & ipc.listenHwnd))
        
    'VaToOffset = ipc.SendCmdRecvText("vatooff:" & va & ":" & ipc.listenHwnd)
End Function

Function getFunc(IndexVaOrName) 'as JSON string
    getFunc = ipc.SendCmdRecvText("getfunc:" & IndexVaOrName & ":" & ipc.listenHwnd)
End Function

Function funcMap(ByRef count As Long)  'not really for idajs, for integrating idacompare functionality
    Dim path As String, p As String
    'fprintf(fp, "%d,%s,0x%llx,0x%llx,0x%x,%d\n", i, name.c_str(), ua1, ua2, (fu->end_ea - fu->start_ea), fu->referers);
    path = fso.GetFreeFileName(Environ("temp"))
    p = Replace(path, ":", "_") 'tokinizer bs
    count = ipc.SendCmdRecvInt("funcmap:" & p)
    If count > 0 Then funcMap = path Else fso.deleteFile path
End Function

Function getSects()
    getSects = ipc.SendCmdRecvText("getsegs:" & ipc.listenHwnd)
End Function

Function delSect(nameOrBase)
    delSect = ipc.SendCmdRecvInt("delseg:" & nameOrBase)
End Function

Function sectExists(nameOrBase)
    sectExists = ipc.SendCmdRecvInt("segexists:" & nameOrBase)
End Function

Function addSect(base, Size, Name)
        addSect = ipc.SendCmdRecvInt("addseg:" & base & ":" & Size & ":" & Name)
End Function

Function importFile(va, path, optNewSegName)
    
    On Error GoTo hell
    Dim m As modes
    
    m = mUnsigned
    path = Replace(path, "/", "\")
    If Not FileExists(CStr(path)) Then GoTo hell
    
    Dim b() As Byte, f As Long, ul As New ULong64, i As Long
    
    If TypeName(va) = "String" Then
        If InStr(1, va, "0x", vbTextCompare) > 0 Then m = mHex
        If AnyOfTheseInstr(va, "a,b,c,d,e,f") Then m = mHex
    End If
    
    ul.use0x = True
    ul.useTick = False
    Call ul.fromString(va, m)
    
    If Len(optNewSegName) > 0 Then
        If sectExists(ul.toString(mHex)) = 0 Then
            If addSect(ul.toString(mHex), FileLen(path), optNewSegName) = 0 Then GoTo hell
        End If
    End If
     
    importFile = ipc.SendCmdRecvInt("importpatch:" & Replace(path, ":", "_") & ":" & ul.toString(mHex))
    
Exit Function
hell:
    importFile = -1
End Function

'Function importFile(va, path, optNewSegName)
'
'    On Error GoTo hell
'
'    path = Replace(path, "/", "\")
'    If Not FileExists(CStr(path)) Then GoTo hell
'
'    Dim b() As Byte, f As Long, ul As New ULong64, i As Long
'
'    ul.use0x = True
'    ul = va
'
'    f = FreeFile
'    Open path For Binary As f
'    ReDim b(LOF(f) - 1)
'    Get f, , b()
'    Close f
'
'    If Len(optNewSegName) > 0 Then
'        If segExists(va) = 0 Then
'            If addSegment(va, UBound(b), optNewSegName) = 0 Then GoTo hell
'        End If
'    End If
'
'    For i = 0 To UBound(b)
'        patchByte ul.toString(), b(i)
'        ul = ul.add(1)
'    Next
'
'    importFile = 1
'
'Exit Function
'hell:
'    importFile = 0
'End Function


Function add_enum(Name) As Long
    add_enum = ipc.SendCmdRecvInt("addenum:" & Name)
End Function

Function get_enum(Name) As Long
    get_enum = ipc.SendCmdRecvInt("getenum:" & Name)
End Function

'todo x64 safe?
Function add_enum_member(id, Name, val) As Long
    'addenummem:enumid:value:name
    add_enum_member = ipc.SendCmdRecvInt("addenummem:" & id & ":" & val & ":" & Name)
End Function

Function immvals(ea)
    Dim a, b
    a = x64IntToHex(ea)
    immvals = ipc.SendCmdRecvText("immvals:" & a & ":" & ipc.listenHwnd)
    MsgBox immvals
End Function

'Function getopn(ea)
'    getopn = ipc.SendCmdRecvInt("getopn:" & ea)
'End Function

Function getopv(ea, n)
    Dim a, b
    a = x64IntToHex(ea)
    getopv = ipc.SendCmdRecvText("getopv:" & a & ":" & n & ":" & ipc.listenHwnd)
End Function

'flagts = bit flags(1 = va, 2 = disasm, 4 = comments)
'so full dump would be 7
'    Const dump_addr = 1
'    Const dump_bytes = 2
'    Const dump_comments = 4
Function dumpFunc(i, flags)
    Dim p As String, r As Long
    'If flags = 0 Then flags = 7
    p = fso.GetFreeFileName(Environ("temp"))
    r = ipc.SendCmdRecvInt("dumpfunc:" & i & ":" & flags & ":" & Replace(p, ":", "_")) 'strtok :(
    If r = 1 Then dumpFunc = fso.readFile(p)
    fso.deleteFile p
End Function

Function dumpFuncBytes(i)
    Dim p As String, r As Long
    p = fso.GetFreeFileName(Environ("temp"))
    r = ipc.SendCmdRecvInt("dumpfuncbytes:" & i & ":" & Replace(p, ":", "_"))
    If r = 1 Then dumpFuncBytes = fso.readFile(p)
    fso.deleteFile p
End Function

Private Sub Class_Initialize()
    Set ipc = New CIpc
    ipc.FindClient "IDA_SERVER2"
    'ipc.Listen ipc.listenHwnd
    tmp_x.use0x = True
    tmp_x.useTick = False
End Sub

Property Get timeout()
    timeout = frmMain.txtjs.timeout
End Property

Property Let timeout(v)
    On Error Resume Next
    frmMain.txtjs.timeout = CLng(v)
End Property

Property Get is32Bit() As Boolean
    is32Bit = Not is64BitMode
End Property

Property Get isUp() As Boolean
    isUp = IIf(IsWindow(ipc.RemoteHWND) = 1, True, False)
End Property

Function targetIs_x86() As Boolean

    If Me.bits = 64 Then
        m_is64BitMode = True
        targetIs_x86 = False
    Else
        targetIs_x86 = True
        m_is64BitMode = False
    End If
End Function

Property Get bits() As Long
    bits = ipc.quickCall(qcmisX64Disasm)
End Property

Sub do_events()
    DoEvents
End Sub

Sub die(msg)
    frmMain.txtjs.timeout = 1
    frmMain.txtjs.StopExecution
    t msg
End Sub

Sub clearDecompilerCache()
    Me.quickCall 40, 0
End Sub

Property Let caption(msg)
    frmMain.caption = msg
    frmMain.refresh
    DoEvents
End Property

Function alert(msg)
    If IsArray(msg) Then
        MsgBox "Array: " & vbCrLf & vbCrLf & Join(msg, vbCrLf), vbInformation, "IDAJScript"
    Else
        MsgBox msg, vbInformation, "IDAJScript"
    End If
End Function

Function message(msg)
    ipc.Send "msg:" & msg
End Function

Function makeStr(va, Optional ascii As Boolean = True)
    Dim a, b
    a = x64IntToHex(va)
    ipc.Send "makestring:" & a & ":" & IIf(ascii, "ascii", "unicode")
End Function

Function makeUnk(va, Size)
    Dim a, b
    a = x64IntToHex(va)
    ipc.Send "makeunk:" & a & ":" & Size
End Function

Property Get loadedFile() As String
    loadedFile = ipc.SendCmdRecvText("loadedfile:" & ipc.listenHwnd)
End Property

Sub t(data)
    frmMain.Text1.text = frmMain.Text1.text & vbCrLf & data
    frmMain.Text1.SelStart = Len(frmMain.Text1.text)
    DoEvents
End Sub

Sub clearLog()
    frmMain.Text1.text = Empty
End Sub

'todo: make x64 safe
Function patchString(va, str, Optional isUnicode = False)
    
    Dim b() As Byte, i As Long
    b() = StrConv(str, vbFromUnicode)
    For i = 0 To UBound(b)
        patchByte va, b(i)
        If isUnicode Then patchByte va + 1, 0
        va = IIf(isUnicode, va + 2, va + 1)
    Next
    
End Function

Function patchByte(va, newVal)
    Dim a, b
    a = x64IntToHex(va)
    If CInt(newVal) > 255 Then Err.Raise 1, "PatchByte", "byte value must be 0-254"
    ipc.Send "patchbyte:" & a & ":" & newVal
End Function



Function intToHex(X)
    On Error Resume Next
     
    'keep it 32bit if we can... (-1 went to full 64bit)
    intToHex = Hex(CLng(Replace(X, "0x", "&h")))
    
    If Err.Number = 0 Then
        If Len(intToHex) = 1 Then intToHex = "0" & intToHex
        intToHex = "0x" & intToHex
        Exit Function
    End If
    
    If Not tmp_x.fromString(X) Then
        frmMain.List1.AddItem "Failed to convert x: " & X
        Exit Function
    End If
    
    intToHex = tmp_x.toString(mHex)

End Function

Function getAsm(va)
    Dim a, b
    a = x64IntToHex(va)
    getAsm = ipc.SendCmdRecvText("getasm:" & a & ":" & ipc.listenHwnd)
End Function

Function instSize(offset)
    Dim a, b
    a = x64IntToHex(offset)
    instSize = ipc.SendCmdRecvInt("decodeins:" & a) ' quickCall(qcmInstLen, CLng(offset))
End Function

Function isCode(offset)
    Dim a, b
    a = x64IntToHex(offset)
    isCode = ipc.SendCmdRecvInt("iscode:" & a) 'quickCall(qcmIsCode, CLng(offset))
End Function

Function isData(offset)
    Dim a, b
    a = x64IntToHex(offset)
    isData = ipc.SendCmdRecvInt("isdata:" & a) 'quickCall(qcmIsData, CLng(offset))
End Function

Private Function csvToHex(csv) As String
    On Error Resume Next
    Dim tmp() As String, X, Y()
    tmp = Split(csv, ",")
    For Each X In tmp
        push Y, tmp_x.setVal(X).toString(mHex)
    Next
    csvToHex = Join(Y, ",")
End Function

Function xRefsTo(offset) 'returns CSV list
    Dim tmp
    Dim a, b
    a = x64IntToHex(offset)
    tmp = ipc.SendCmdRecvText("refsto:" & a & ":" & ipc.listenHwnd)
    If Right(tmp, 1) = "," Then tmp = Mid(tmp, 1, Len(tmp) - 1)
    If is64BitMode Then
        xRefsTo = csvToHex(tmp)
    Else
       'tmp = Split(tmp, ",") javascript cant deal with string() must be variant()?
       xRefsTo = tmp
    End If
End Function

Function xRefsFrom(offset) 'returns CSV list
    Dim tmp
    Dim a, b
    a = x64IntToHex(offset)
    tmp = ipc.SendCmdRecvText("refsfrom:" & a & ":" & ipc.listenHwnd)
    If Right(tmp, 1) = "," Then tmp = Mid(tmp, 1, Len(tmp) - 1)
    If is64BitMode Then
        xRefsFrom = csvToHex(tmp)
    Else
        'tmp = Split(tmp, ",") javascript cant deal with string() must be variant()?
        xRefsFrom = tmp
    End If
End Function


Function getName(offset)
    Dim a, b
    a = x64IntToHex(offset)
    getName = ipc.SendCmdRecvText("getname:" & a & ":" & ipc.listenHwnd)
    If getName = "NULL" Then getName = ""
End Function

 Function functionName(functionIndex)
    functionName = ipc.SendCmdRecvText("funcname:" & functionIndex & ":" & ipc.listenHwnd)
 End Function

'todo: make x64 safe
Function hideBlock(offset, endAt)
    Dim X, i As Long
    
    If offset < 1 Or endAt < 1 Then
        MsgBox "Address would go negative", vbInformation
        Exit Function
    End If
    
    For i = offset To endAt
        hideEA i
    Next
    
    refresh
End Function

Function showBlock(offset, endAt)
    Dim X, i As Long, lt1 As Boolean, lt2 As Boolean
    Dim a, b
    
    a = x64IntToHex(offset)
    lt1 = tmp_x.lessThan(1)
    
    b = x64IntToHex(endAt)
    lt2 = tmp_x.lessThan(1)
    
    If lt1 Or lt2 Then
        MsgBox "Address would go negative", vbInformation
        Exit Function
    End If
    
    'todo: make x64 safe
    For i = offset To endAt
        showEA i
    Next
    
    refresh
End Function

Function setname(offset, Name)
    Dim a, b
    a = x64IntToHex(offset)
    setname = ipc.Send("setname:" & a & ":" & CStr(Name))
 End Function

Sub addComment(offset, comment)
    Dim a, b
    a = x64IntToHex(offset)
    ipc.Send "addcomment:" & a & ":" & comment
End Sub

Function getComment(offset)
    Dim a, b
    a = x64IntToHex(offset)
    getComment = ipc.SendCmdRecvText("getcomment:" & a & ":" & ipc.listenHwnd)
    If getComment = "NULL" Then getComment = Empty
End Function

 Sub addCodeXRef(offset, tova)
    Dim a, b
    a = x64IntToHex(offset)
    b = x64IntToHex(tova)
    ipc.Send "addcodexref:" & a & ":" & b
 End Sub
 

  Sub addDataXRef(offset, tova)
    Dim a, b
    a = x64IntToHex(offset)
    b = x64IntToHex(tova)
    ipc.Send "adddataxref:" & a & ":" & b
 End Sub
 

 Sub delCodeXRef(offset, tova)
    Dim a, b
    a = x64IntToHex(offset)
    b = x64IntToHex(tova)
    ipc.Send "delcodexref:" & a & ":" & b
 End Sub
 
 
 Sub delDataXRef(offset, tova)
    Dim a, b
    a = x64IntToHex(offset)
    b = x64IntToHex(tova)
    ipc.Send "deldataxref:" & a & ":" & b
 End Sub
 
 'todo x64: -- wrong on the ida plugin side
Function funcVAByName(Name)
    If Not is64BitMode Then
        funcVAByName = ipc.SendCmdRecvInt("name_va:" & Name)
    Else
        funcVAByName = x64IntToHex(ipc.SendCmdRecvText("name_va:" & Name & ":" & ipc.listenHwnd))
    End If
End Function

Function renameFunc(oldname, newName) As Boolean
    renameFunc = IIf(ipc.SendCmdRecvInt("rename:" & oldname & ":" & newName) = 1, True, False)
End Function

 'todo: not working x64
Function find(startEa, endea, hexStr) '-1 if fail
    Dim a, b
    a = x64IntToHex(startEa)
    b = x64IntToHex(endea)
    'findcode:start:end:hexstr
    find = ipc.SendCmdRecvInt("findcode:" & a & ":" & b & ":" & hexStr)
End Function

Function decompile(va) As String
    Dim pth As String, r As Long, sva As String
    
    pth = Environ("temp")
    pth = fso.GetFreeFileName(pth)
    sva = x64IntToHex(va)
                                                        'its our token we will need to replace it latter :-\ foresight denied!
    r = ipc.SendCmdRecvInt("decompile:" & sva & ":" & Replace(pth, ":", "_"))
    
    If r = 1 And fso.FileExists(pth) Then
        decompile = fso.readFile(pth)
        
    End If
    
End Function



'--------------[ QUICK CALLS ]----------------------------------------

'x86 is unchanged with quickcalls because
' 1) already debugged, 2) 3x faster,
' --> 3) it lets JS deal with results as numbers normally and not make everything an x64 string! <--
' yes I hate the extra code and special cases js (and vb) problem...

Function jump(va)
    On Error Resume Next
    
    If Not is64BitMode Then
        ipc.quickCall qcmJmpAddr_32, cCLng(va)
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        ipc.Send "jmp:" & tmp_x.toString(mHex)
    End If
    
End Function

Function jumpRVA(rva)
    On Error Resume Next
    ipc.quickCall qcmJmpRVA, cCLng(rva)
End Function

Function refresh()
    ipc.quickCall qcmRefresh
End Function

Function undefine(va)
    On Error Resume Next
    If Not is64BitMode Then
        ipc.quickCall qcmUndef_32, cCLng(va)
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        ipc.Send "undefine:" & tmp_x.toString(mHex)
    End If
End Function

Function showEA(va)
    On Error Resume Next
    If Not is64BitMode Then
        ipc.quickCall qcmShow_32, cCLng(va)
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        ipc.Send "show:" & tmp_x.toString(mHex)
    End If
End Function

Function hideEA(va)
    On Error Resume Next
    If Not is64BitMode Then
        ipc.quickCall qcmHide_32, cCLng(va)
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        ipc.Send "hide:" & tmp_x.toString(mHex)
    End If
End Function

 Sub removeName(va)
    On Error Resume Next
    If Not is64BitMode Then
        ipc.quickCall qcmRemName_32, cCLng(va)
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Sub
        End If
        ipc.Send "remname:" & tmp_x.toString(mHex)
    End If
 End Sub

Sub makeCode(va)
    On Error Resume Next
    If Not is64BitMode Then
        ipc.quickCall qcmMakeCode_32, cCLng(va)
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Sub
        End If
        ipc.Send "makecode:" & tmp_x.toString(mHex)
    End If
End Sub

Function funcIndexFromVA(va)
    On Error Resume Next
    If Not is64BitMode Then
        funcIndexFromVA = ipc.quickCall(qcmFuncIdx_32, cCLng(va))
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        funcIndexFromVA = ipc.SendCmdRecvInt("funcindex:" & tmp_x.toString(mHex))
    End If
End Function

Function nextEA(va)
    On Error Resume Next
    If Not is64BitMode Then
        nextEA = ipc.quickCall(qcmNextEa_32, cCLng(va))
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        nextEA = x64IntToHex(ipc.SendCmdRecvText("nextea:" & tmp_x.toString(mHex) & ":" & ipc.listenHwnd))
    End If
End Function

Function prevEA(va)
    On Error Resume Next
    If Not is64BitMode Then
        prevEA = ipc.quickCall(qcmPrevEa_32, cCLng(va))
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        prevEA = x64IntToHex(ipc.SendCmdRecvText("prevea:" & tmp_x.toString(mHex) & ":" & ipc.listenHwnd))
    End If
End Function

Function x64IntToHex(va) As String
    
    If Not tmp_x.fromString(va, mUnsigned) Then
        frmMain.List1.AddItem "Failed to convert va: " & va
        Exit Function
    End If
    x64IntToHex = tmp_x.toString(mHex)
    
End Function

Function funcCount() As Long 'alias for numfuncs for intellisense which is sorted alphabetically..
    funcCount = numFuncs()
End Function

 Function numFuncs() As Long
    numFuncs = ipc.quickCall(qcmNumFuncs)
 End Function

 Function functionStart(functionIndex)
     On Error Resume Next
     If Not is64BitMode Then
        functionStart = ipc.quickCall(qcmFuncStart_32, cCLng(functionIndex))
     Else
        functionStart = x64IntToHex(ipc.SendCmdRecvText("funcstart:" & functionIndex & ":" & ipc.listenHwnd))
     End If
 End Function

 Function functionEnd(functionIndex)
     On Error Resume Next
     If Not is64BitMode Then
        functionEnd = ipc.quickCall(qcmFuncEnd_32, cCLng(functionIndex))
     Else
        functionEnd = x64IntToHex(ipc.SendCmdRecvText("funcend:" & functionIndex & ":" & ipc.listenHwnd))
     End If
 End Function
  
 Function readByte(va)
     On Error Resume Next
     If Not is64BitMode Then
        readByte = CByte(ipc.quickCall(qcmReadByte_32, cCLng(va)))
     Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        readByte = ipc.SendCmdRecvText("readbyte:" & tmp_x.toString(mHex) & ":" & ipc.listenHwnd)
        readByte = Right(readByte, 2)
     End If
End Function

Function readLong(va)
    On Error Resume Next
    If Not is64BitMode Then
         If va = 0 Or va = -1 Then Exit Function
         readLong = CLng(ipc.quickCall(qcmReadLong_32, cCLng(va)))
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        readLong = ipc.SendCmdRecvInt("getlong:" & tmp_x.toString(mHex)) ' & ":" & ipc.listenHwnd)
    End If
End Function

Function readQWord(va)
    On Error Resume Next
    If Not tmp_x.fromString(va) Then
        frmMain.List1.AddItem "Failed to convert va: " & va
        Exit Function
    End If
    readQWord = ipc.SendCmdRecvText("getx64:" & tmp_x.toString(mHex) & ":" & ipc.listenHwnd)
End Function

Function readShort(va)
    On Error Resume Next
    If Not is64BitMode Then
         If va = 0 Or va = -1 Then Exit Function
         readShort = CLng(ipc.quickCall(qcmReadShort_32, cCLng(va)))
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        readShort = ipc.SendCmdRecvInt("getword:" & tmp_x.toString(mHex)) '& ":" & ipc.listenHwnd)
    End If
End Function

Function readStr(va, isAscii, maxLeng)
     On Error Resume Next
     Dim j As Long, bs, b, lastWas0 As Boolean, tmp As String
     Dim t2 As ULong64
     
     maxLeng = CLng(maxLeng)
     If maxLeng = 0 Then maxLeng = 500
     
     isAscii = IIf(isAscii = 1, True, False)
     
     If Not tmp_x.fromString(va) Then
        frmMain.List1.AddItem "Failed to convert va: " & va
        Exit Function
     End If
     
     Do While 1
     
        Set t2 = tmp_x.add(j)
        t2.useTick = False
        t2.use0x = True
        
        bs = ipc.SendCmdRecvText("readbyte:" & t2.toString(mHex) & ":" & ipc.listenHwnd)
        bs = "&h" & Right(bs, 2)
        b = CLng(bs)
        
        If isAscii Then
            If b = 0 Then Exit Do
        Else
            If b = 0 And lastWas0 Then Exit Do
        End If
        
        lastWas0 = (b = 0)
        If b <> 0 Then tmp = tmp & Chr(b)
        
        j = j + 1
        If j <> -1 Then
            If j > maxLeng Then Exit Do
        End If
        
     Loop
     
     readStr = tmp
     
End Function

Function originalByte(va)
    On Error Resume Next
    
    If Not is64BitMode Then
         If va = 0 Or va = -1 Then Exit Function
         originalByte = CByte(ipc.quickCall(qcmOrgByte_32, cCLng(va)))
    Else
        If Not tmp_x.fromString(va) Then
            frmMain.List1.AddItem "Failed to convert va: " & va
            Exit Function
        End If
        originalByte = ipc.SendCmdRecvInt("orgbyte:" & tmp_x.toString(mHex))
        originalByte = Right(originalByte, 2)
    End If
End Function

Function imageBase()
    If Not is64BitMode Then
         imageBase = ipc.quickCall(qcmImgBase_32)
    Else
        imageBase = x64IntToHex(ipc.SendCmdRecvText("imgbase:" & ipc.listenHwnd))
    End If
End Function

Property Get version() As Long
    version = ipc.quickCall(qcmIDAVer)
End Property

Function screenEA()
    If Not is64BitMode Then
        screenEA = ipc.quickCall(qcmScreenEA_32)
    Else
        screenEA = x64IntToHex(ipc.SendCmdRecvText("screenea:" & ipc.listenHwnd))
    End If
End Function

Function enableIDADebugMessages(Optional enabled As Boolean = True)
    ipc.quickCall qcmDebugMessages, IIf(enabled, 1, 0)
End Function

Function quickCall(msg, Optional arg1 = 0) As Long
    On Error Resume Next
    quickCall = ipc.quickCall(cCLng(msg), cCLng(arg1))
End Function


' Sub DelFunc(addr)
'    Module1.DelFunc CLng(addr)
' End Sub
'
'Sub AddProgramComment(cmt)
'   Module1.AddProgramComment CStr(cmt)
'End Sub
'
' Function ScreenEA()
'    ScreenEA = Module1.ScreenEA
' End Function
'


'Function GetAsmBlock(start, leng)
'    GetAsmBlock = GetAsmRange(CLng(start), CLng(leng))
'End Function
'
'
'Function GetBytes(start, leng)
'    Dim b() As Byte, ret(), i As Integer
'
'    ReDim b(leng)
'    ReDim ret(leng)
'
'    Module1.GetBytes CLng(start), b(0), CLng(leng)
'
'    For i = 0 To leng
'        ret(i) = b(i)
'    Next
'
'    GetBytes = ret()
'
'End Function
'
'

'
'
'Sub AnalyzeArea(startat, endat)
'    Module1.AnalyzeArea CLng(startat), CLng(endat)
'End Sub
'

Function askValue(Optional prompt, Optional defVal) As String
    askValue = InputBox(prompt, , defVal)
End Function

Function confirm(prompt) As Long
    confirm = IIf(MsgBox(prompt, vbYesNo) = vbYes, 1, 0)
End Function

Sub exec(cmd)
   On Error Resume Next
   Shell cmd, vbNormalFocus
End Sub

Function expandPath(path)
    
    Dim temp
    Dim buf As String
    Dim sz As Long
    
    If InStr(1, path, "%sp%", vbTextCompare) > 0 Then
        If Len(frmMain.loadedFile) = 0 Then
            MsgBox "can not use %sp% variable yet in file path file not saved!"
            Exit Function
        End If
        
        temp = fso.GetParentFolder(frmMain.loadedFile)
        path = Replace(path, "%sp%", temp, , , vbTextCompare)
    End If

    If InStr(1, path, "%desktop%", vbTextCompare) > 0 Then
        temp = GetSpecialFolder(sf_DESKTOP)
        path = Replace(path, "%desktop%", temp, , , vbTextCompare)
    End If
    
    If InStr(path, "%") < 1 Then GoTo errHandler
    
    sz = ExpandEnvironmentStrings(path, ByVal buf, 0)
    If sz = 0 Then GoTo errHandler
    
    buf = Space(sz + 100)
    sz = ExpandEnvironmentStrings(path, ByVal buf, Len(buf))
    If sz = 0 Then GoTo errHandler
    
    buf = Left(buf, sz - 1)
    expandPath = buf
    
    Exit Function

errHandler:
    expandPath = path

End Function

Function readFile(filename) As Variant
  Dim f As Long
  Dim temp As Variant
  
  On Error Resume Next
   
  filename = expandPath(filename)
  
  f = FreeFile
  temp = ""
   Open filename For Binary As #f        ' Open file.(can be text or image)
     temp = Input(FileLen(filename), #f) ' Get entire Files data
   Close #f
   readFile = temp
End Function

Sub writeFile(path, it)

    On Error Resume Next
    Dim temp As String
    Dim f As Long
    
    path = expandPath(path)
  
    f = FreeFile
    Open path For Output As #f
    Print #f, it
    Close f
    
End Sub

Sub appendFile(path, it)
    On Error Resume Next
    Dim f As Long
    path = expandPath(path)
    f = FreeFile
    Open path For Append As #f
    Print #f, it
    Close f
End Sub

Function readFileHex(fpath)
    On Error GoTo hell
    Dim b() As Byte, f As Long, i As Long, ret As String
    
    If Not FileExists(fpath) Then Exit Function
    
    f = FreeFile
    Open fpath For Binary As f
    ReDim b(LOF(f))
    Get f, , b
    Close f
    
    For i = 0 To UBound(b)
        ret = ret & Right("0" & Hex(b(i)), 2)
    Next
    
    readFileHex = ret
    
hell:
End Function

Function FileExists(path) As Boolean
  On Error GoTo hell
  Dim tmp As String
  path = expandPath(path)
  tmp = Replace(path, "'", Empty)
  tmp = Replace(tmp, """", Empty)
  If Len(tmp) = 0 Then Exit Function
  If Dir(tmp, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
  Exit Function
hell: FileExists = False
End Function

Function deleteFile(fpath) As Boolean
 On Error GoTo hadErr
    fpath = expandPath(fpath)
    Kill fpath
    deleteFile = True
 Exit Function
hadErr:
'MsgBox "DeleteFile Failed" & vbCrLf & vbCrLf & fpath
deleteFile = False
End Function

Function getClipboard()
    getClipboard = Clipboard.GetText()
End Function

Function setClipboard(X)
    Clipboard.Clear
    Clipboard.SetText X
End Function

Function openFileDialog() As String
    openFileDialog = dlg.OpenDialog(AllFiles)
End Function

Function saveFileDialog() As String
    saveFileDialog = dlg.SaveDialog(AllFiles)
End Function

Function benchMark() As Long
    Dim i As LARGE_INTEGER
    QueryPerformanceCounter i
    benchMark = i.lowpart
End Function

Function hexdump(X) As String
    hexdump = Module1.hexdump(CStr(X), , , hoDump)
End Function

Function hexStr(X) As String
    hexStr = Module1.hexdump(CStr(X), , , hoHexOnly)
End Function

Function toBytes(hexStr) As String
    Dim out As String
    If Module1.toBytes(CStr(hexStr), out) Then toBytes = out
End Function

''this has problems with unicode chars
'Function reSearch(fpath, pattern)
'
'    On Error GoTo hell
'
'    Dim f As Long, buf() As Byte, pointer As Long
'    Dim b As String
'    Dim m As Match
'    Dim X, foff
'
'    Dim d As New RegExp
'    Dim mc As MatchCollection
'    Dim ret() As String
'
'
'    d.pattern = pattern '"[\w0-9 /?.\-_=+$\\@!*\(\)#%~`\^&\|\{\}\[\]:;'""<>\,]{" & txtMinLen & ",}"
'    d.Global = True
'
'    f = FreeFile
'    Open fpath For Binary Access Read As f
'    ReDim buf(LOF(f))
'    Get f, , buf()
'    Close f
'
'    b = StrConv(buf, vbUnicode)
'    Set mc = d.Execute(b)
'
'    For Each m In mc
'        DoEvents
'        foff = m.FirstIndex + pointer - 1
'        push ret(), foff & ":" & Replace(m.value, Chr(0), Empty)
'    Next
'
'
'
''    ReDim buf(9000)
''    Open fpath For Binary Access Read As f
''
''    Do While pointer < LOF(f)
''        pointer = Seek(f)
''        X = LOF(f) - pointer
''        If X < 1 Then Exit Do
''        If X < 9000 Then ReDim buf(X)
''        Get f, , buf()
''
''        b = StrConv(buf, vbUnicode)
''        Set mc = d.Execute(b)
''
''        For Each m In mc
''            DoEvents
''            foff = m.FirstIndex + pointer - 1
''            push ret(), foff & ":" & Replace(m.value, Chr(0), Empty)
''        Next
''
''    Loop
'
'    On Error Resume Next
'hell:
'    Close f
'    reSearch = Join(ret, Chr(5) & "!!" & Chr(5))
'    'MsgBox reSearch
'
'End Function


'Function refListToArray(x) As Long() 'no way to use a vb6 array in js?
'    On Error Resume Next
'    Dim i As Long, y() As Long
'    x = Split(x, ",")
'    ReDim y(UBound(x) - 1)
'    For i = 0 To UBound(x) - 1
'        y(i) = CLng(x(i))
'    Next
'    refListToArray = y
'End Function
 
'Function InstSize(offset)
'    'there has to be a real way to do this
'    Dim x As String, tmp As String, i As Long, n As String
'    Dim firstea As Long, secondea As Long
'    Dim leng As Long
'
'    leng = 40
'    firstea = 0
'    secondea = 0
'    For i = 0 To leng - 1
'        tmp = GetAsm(offset + i)
'        If tmp = "Fail" Then tmp = Empty
'        If Len(tmp) > 0 Then
'            If firstea = 0 Then
'                firstea = offset + i
'            ElseIf secondea = 0 Then
'                 secondea = offset + i
'            End If
'            If firstea > 0 And secondea > 0 Then Exit For
'        End If
'    Next
'
'    InstSize = secondea - firstea
'
'End Function
