Attribute VB_Name = "modGeneral"
Option Explicit

Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2

Public hUtypes As Long
Public uTypesPath As String
Global fso As New CFileSystem2

Public Enum hexOutFormats
    hoDump
    hoSpaced
    hoHexOnly
End Enum

Public Enum InputFormats
    ifHex = 1
    ifDecimal = 2
    ifString = 3
'    ifHexDump = 4
End Enum




Function cCLng(X) As Long
    On Error Resume Next
    cCLng = CLng(Replace(X, "0x", "&h"))
End Function

Function KeyExistsInCollection(c As Collection, val As String) As Boolean
    On Error GoTo nope
    Dim t
    t = c(val)
    KeyExistsInCollection = True
 Exit Function
nope: KeyExistsInCollection = False
End Function

Function isIde() As Boolean
    On Error GoTo out
    Debug.Print 1 / 0
out: isIde = Err
End Function

Function ensureUTypes() As Boolean
    
    On Error Resume Next
    
    If hUtypes <> 0 Then
        ensureUTypes = True
        Exit Function
    End If
    
    Dim pth As String, b() As Byte, f As Long
    Dim thisDll As String, pd(), parentDir
    
    thisDll = GetDllPath("vbUtypes.dll")
    If Len(thisDll) > 0 Then push pd, fso.GetParentFolder(thisDll)
    push pd, App.path
    push pd, Environ("WinDir")
    push pd, App.path & "\binary_snapshot"
    
    For Each parentDir In pd
        pth = parentDir & "\UTypes.dll"
        If Not fso.FileExists(pth) Then pth = parentDir & "\UTypes.dll"
        If Not fso.FileExists(pth) Then pth = parentDir & "\..\UTypes.dll"
        If Not fso.FileExists(pth) Then pth = parentDir & "\..\..\UTypes.dll"
        If Not fso.FileExists(pth) Then pth = parentDir & "\..\..\..\UTypes.dll"
        If fso.FileExists(pth) Then Exit For
    Next
    
'    If Not FileExists(pth) Then

'        pth = App.path & "\UTypes.dll"
'        b() = LoadResData("UTYPES", "DLLS")
'        If AryIsEmpty(b) Then
'            MsgBox "Failed to find UTypes.dll in resource?"
'            Exit Function
'        End If
'
'        f = FreeFile
'        Open pth For Binary As f
'        Put f, , b()
'        Close f
        
        'MsgBox "Dropped utypes.dll to: " & pth & " - Err: " & Err.Number
'    End If
  
    hUtypes = LoadLibrary(pth)
    If hUtypes = 0 Then Exit Function

    uTypesPath = pth
    ensureUTypes = True
    
End Function

Public Function GetDllPath(Optional dll As String = "vbUtypes.dll") As String
     Dim h As Long, ret As String
     ret = Space(500)
     h = GetModuleHandle(dll)
     h = GetModuleFileName(h, ret, 500)
     If h > 0 Then ret = Mid(ret, 1, h)
     GetDllPath = ret
End Function

Sub push(ary, value) 'this modifies parent ary object
    On Error GoTo init
    Dim X
       
    X = UBound(ary)
    ReDim Preserve ary(X + 1)
    
    If IsObject(value) Then
        Set ary(X + 1) = value
    Else
        ary(X + 1) = value
    End If
    
    Exit Sub
init:
    ReDim ary(0)
    If IsObject(value) Then
        Set ary(0) = value
    Else
        ary(0) = value
    End If
End Sub


Function AnyOfTheseInstr(sIn, csvCmp) As Boolean
    Dim tmp() As String, i As Integer
    tmp() = Split(csvCmp, ",")
    For i = 0 To UBound(tmp)
        tmp(i) = Trim(tmp(i))
        If Len(tmp(i)) > 0 And InStr(1, sIn, tmp(i), vbTextCompare) > 0 Then
            AnyOfTheseInstr = True
            Exit Function
        End If
    Next
End Function

Function hexdump(bAryOrStrData, Optional ByVal length As Long = -1, Optional ByVal startAt As Long = 1, Optional hexFormat As hexOutFormats = hoDump) As String
    Dim s() As String, chars As String, tmp As String
    On Error Resume Next
    Dim ary() As Byte
    Dim offset As Long
    Const LANG_US = &H409
    Dim i As Long, tt, h, X
    Dim hexOnly As Long
    
    offset = 0
    If hexFormat <> hoDump Then hexOnly = 1
    
    If TypeName(bAryOrStrData) = "Byte()" Then
        ary() = bAryOrStrData
    Else
        ary = StrConv(CStr(bAryOrStrData), vbFromUnicode, LANG_US)
    End If
    
    If startAt < 1 Then startAt = 1
    If length < 1 Then length = -1
    
    While startAt Mod 16 <> 0
        startAt = startAt - 1
    Wend
    
    startAt = startAt + 1
    
    chars = "   "
    For i = startAt To UBound(ary) + 1
        tt = Hex(ary(i - 1))
        If Len(tt) = 1 Then tt = "0" & tt
        tmp = tmp & tt & " "
        X = ary(i - 1)
        'chars = chars & IIf((x > 32 And x < 127) Or x > 191, Chr(x), ".") 'x > 191 causes \x0 problems on non us systems... asc(chr(x)) = 0
        chars = chars & IIf((X > 32 And X < 127), Chr(X), ".")
        If i > 1 And i Mod 16 = 0 Then
            h = Hex(offset)
            While Len(h) < 6: h = "0" & h: Wend
            If hexOnly = 0 Then
                push s, h & "   " & tmp & chars
            Else
                push s, tmp
            End If
            offset = offset + 16
            tmp = Empty
            chars = "   "
        End If
        If length <> -1 Then
            length = length - 1
            If length = 0 Then Exit For
        End If
    Next
    
    'if read length was not mod 16=0 then
    'we have part of line to account for
    If tmp <> Empty Then
        If hexOnly = 0 Then
            h = Hex(offset)
            While Len(h) < 6: h = "0" & h: Wend
            h = h & "   " & tmp
            While Len(h) <= 56: h = h & " ": Wend
            push s, h & chars
        Else
            push s, tmp
        End If
    End If
    
    hexdump = Join(s, vbCrLf)
    
    If hexOnly <> 0 Then
        If hexFormat = hoHexOnly Then hexdump = Replace(hexdump, " ", "")
        hexdump = Replace(hexdump, vbCrLf, "")
    End If
    
End Function

Public Function toBytes(ByVal hexStr, ByRef outVar, Optional ByVal inputformat As InputFormats = ifHex) As Boolean

'supports:
'11 22 33 44   spaced hex chars
'11223344      run together hex strings
'11,22,33,44   csv hex
'1,2,3,4       csv hex with no lead 0
'121,99,44,255 decimal csv or spaced values
'%xx%yy
'%uxxxx\u7766
'%u6162%63
'isDecimal flag requires csv or spaced values..
'ignores common C source prefixes and characters

    Dim ret As String, X As String, str As String
    Dim r() As Byte, b As Byte, b1 As Byte
    Dim foundDecimal As Boolean, tmp, i, a, a2
    Dim pos As Long, marker As String
    Const LANG_US = &H409
    
    On Error GoTo hell
    
'    If inputformat = ifHexDump Then
'        x = ExtractHexFromDump(hexstr)      'returns just the hex string
'        If Not toBytes(x, r) Then GoTo hell 'now we convert it to actual bytes..
'        GoTo retNow
'    End If
    
    If inputformat = ifString Then
        r() = StrConv(hexStr, vbFromUnicode, LANG_US)
        GoTo retNow
    End If
    
    str = Replace(hexStr, vbCr, Empty)
    str = Replace(str, vbLf, Empty)
    str = Replace(str, vbTab, Empty)
    str = Replace(str, Chr(0), Empty)
    str = Replace(str, "{", Empty)
    str = Replace(str, "}", Empty)
    str = Replace(str, ";", Empty)
    str = Replace(str, "+", Empty)
    str = Replace(str, """""", Empty)
    str = Replace(str, "'", Empty)
    hexStr = str
    
    If InStr(hexStr, "\u") > 0 Then hexStr = Replace(hexStr, "\u", "%u")
    
    If InStr(hexStr, "%u") > 0 Then
        tmp = Split(hexStr, "%u")
        For i = 1 To UBound(tmp)
            a = InStr(tmp(i), "%")
            X = ""
            If a > 1 Then
                X = Mid(tmp(i), a)
                tmp(i) = Mid(tmp(i), 1, a - 1)
            End If
            If Len(tmp(i)) = 3 Then tmp(i) = "0" & tmp(i)
            If Len(tmp(i)) = 4 Then
                a = Mid(tmp(i), 1, 2)
                a2 = Mid(tmp(i), 3, 2)
                tmp(i) = a2 & a
            End If
            If Len(X) > 0 Then tmp(i) = tmp(i) & X
        Next
        hexStr = Join(tmp, "")
    End If
    
    If InStr(hexStr, "%") > 0 Then
        tmp = Split(hexStr, "%")
        For i = 1 To UBound(tmp)
            If Len(tmp(i)) < 2 Then
                tmp(i) = 0 & tmp(i)
            End If
        Next
        hexStr = Join(tmp, "")
    End If
    
    If Len(hexStr) > 4 Then
        pos = FirstOccurance(hexStr, " ,", marker)
        If pos > 0 And pos < 5 Then   'make sure all are double digit hex chars...(also account for decimal 1,11,111,
            tmp = Split(hexStr, marker)
            
            If inputformat = ifDecimal Then
                For i = 0 To UBound(tmp)
                    tmp(i) = Hex(CLng(tmp(i)))
                Next
            End If
            
            For i = 0 To UBound(tmp)
                If Len(tmp(i)) = 1 Then tmp(i) = "0" & tmp(i)
            Next
            
            hexStr = Join(tmp, "")
        End If
    End If
        
    str = Replace(hexStr, " ", Empty)
    str = Replace(str, "0x", Empty)
    str = Replace(str, ",", Empty)
    
    For i = 1 To Len(str) Step 2
        X = Mid(str, i, 2)
        If Not isHexChar(X, b) Then Exit Function
        bpush r(), b
    Next
    
retNow:
    If TypeName(outVar) = "Byte()" Then
        outVar = r
    Else
        outVar = StrConv(r, vbUnicode, LANG_US)
    End If
    
    toBytes = True
    Exit Function
    
hell:
    toBytes = False
    
End Function

Public Function isHexChar(hexValue As String, Optional b As Byte) As Boolean
    On Error Resume Next
    Dim v As Long
    
    If Len(hexValue) = 0 Then GoTo nope
    If Len(hexValue) > 2 Then GoTo nope 'expecting hex char code like FF or 90
    
    v = CLng("&h" & hexValue)
    If Err.Number <> 0 Then GoTo nope 'invalid hex code
    
    b = CByte(v)
    If Err.Number <> 0 Then GoTo nope  'shouldnt happen.. > 255 cant be with len() <=2 ?

    isHexChar = True
    
    Exit Function
nope:
    Err.Clear
    isHexChar = False
End Function

Function FirstOccurance(it, ByVal csvFind As String, ByRef outFoundVal) As Long
    If Len(csvFind) = 0 Then Exit Function
    
    Dim find() As String, X, lowestOffset As Long, lowestIndex As Long, i As Long, a As Long
    Const MAX_LONG = -1
    
    outFoundVal = Empty
    lowestOffset = MAX_LONG
    find = Split(csvFind, ",")
    
    For i = 0 To UBound(find)
        If Len(find(i)) = 0 Then find(i) = ","
        a = InStr(1, it, find(i), vbTextCompare)
        If a > 0 And a < lowestOffset Then
            lowestOffset = a
            lowestIndex = i
        End If
    Next
    
    If lowestOffset = MAX_LONG Then Exit Function
    
    outFoundVal = find(lowestIndex)
    FirstOccurance = lowestOffset
    
End Function


Private Sub bpush(bAry() As Byte, b As Byte) 'this modifies parent ary object
    On Error GoTo init
    Dim X As Long
    
    X = UBound(bAry) '<-throws Error If Not initalized
    ReDim Preserve bAry(UBound(bAry) + 1)
    bAry(UBound(bAry)) = b
    
    Exit Sub

init:
    ReDim bAry(0)
    bAry(0) = b
    
End Sub



