Attribute VB_Name = "Module1"
'in dukdbg CMethod.Parse does not support comments after prototypes...

Public errors As New Collection
Global fso As New CFileSystem3

Function LoadCOMTypes(Optional baseDir As String) As Collection
    
    Dim key As String
    Dim pd As String
    Dim protoEnd As Long, dat, d
    Dim ci As CIntellisenseItem
    Dim intellisense As New Collection
    Dim js As Collection, f, X, tmp
    Dim desc As New Collection
    Dim xtra_comments As New Collection
    
    'these two are aliases for functions in ida. so we hide their functions from the ida obj when parsing latter..dirty hack
    Dim ci_app As CIntellisenseItem, ci_fso As CIntellisenseItem, ci_fn As New CIntellisenseItem
    Dim ci_sect As New CIntellisenseItem
    
    Set LoadCOMTypes = intellisense
    
    If Len(baseDir) = 0 Then
        baseDir = App.path & "\COM"
        If Not fso.FolderExists(baseDir) Then
            baseDir = App.path & "\..\COM"
            If Not fso.FolderExists(baseDir) Then
                MsgBox "Could not locate COM subdirectory to load defs?", vbExclamation
                Exit Function
            End If
        End If
    End If
    
    Set js = fso.GetFolderFiles(baseDir, "*.js")
    
    desc.Add "The address list is a form that allows you to add addresses for one click navigation. Useful to exploring a database", "al"
    desc.Add "the ida object allows you to automate operations and query data from a remote IDA instance. You can select which instance to connect to if there is more than one.", "ida"
    desc.Add "the pb object allows you to update a visual progress bar as your script runs", "pb"
    desc.Add "the fso (FileSystemObject) allows you to do file operations from your scripts", "fso"
    desc.Add "the app object gives you access to application level functions for ease of use features", "app"
    desc.Add "the list object allows you to add entries to a debug list", "list1"
    desc.Add "the x64 object allows you to do basic math on 64 bit numbers and handle them as strings. Javascript & vb6 do not support 64bit numbers so this is required.", "x64"
    desc.Add "the remote object allows you to connect to a remote symbol resolution server to query data from a live process. See my 2017 FireEye blog post for details", "remote"
    desc.Add "global functions are stored in userlib.js. They are convience wrappers that you can add on to", "globals"
    desc.Add "the fn (Function) Object is a special variable that gives intellsense to obj returned by ida.getFunc()", "fn"
    desc.Add "the sect (section) Object is a special variable that gives intellsense to obj contained in the ida.getSects() array", "sect"
    
    'we dont have a better way to do this without mods to duk4vb.ocx, some functions need more info though
    'we dont have a per object list because our surface is small
    xtra_comments.Add "returns a json object {index,name,start,end,size,xrefs,refqty,argsize,tailqty,labelqty,frsize}", "getFunc"
    xtra_comments.Add "returns a json array which we turn into an js object [{name,base,size,index}]", "getSects"
    xtra_comments.Add "gets opcode arg const at index", "getopv"
    
    Dim a() As String
    Set ci_app = New CIntellisenseItem
    ci_app.objName = "app"
    ci_app.Description = desc("app")
    push a, "intToHex(int val)*convert an integer to hex string"
    push a, "t(data)*append message to lower textbox"
    push a, "alert(msg)*typical javascript alert"
    push a, "Property let caption*set the caption of the main script editor window"
    push a, "Sub ClearLog()*clear the debug log"
    push a, "Function getClipboard()*retrieve text from clipboard"
    push a, "Function setClipboard(x)*set the clipboard with specified text"
    push a, "Function BenchMark() As Long*get a benchmark time value from system"
    push a, "Function AskValue( prompt, defVal) As String*prompt the user for a value"
    push a, "Sub Exec(cmd)*execute an external application with command line"
    push a, "Function EnableIDADebugMessages(enabled)*enable/disable debug messages to IDASrvr"
    push a, "Property Get Let timeout As Long*manage script timeout"
    push a, "sub do_events()*allow the script UI to process events so it doesnt freeze and stays responsive"
    push a, "Function hexDump(x) As String*returns a hexdump of the string provided"
    push a, "Function hexstr(x) As String*converts a string to hex characters"
    push a, "Function toBytes(hexstr) As String*converts a hexstring to bytes"
    push a, "Function confirm(prompt) As Long*Shows an alert with Yes/No buttons returning 1/0"
    intellisense.Add ci_app, ci_app.objName
    
    For Each X In a
        tmp = Split(X, "*")
        ci_app.methods.Add tmp(0)
        ci_app.comments.Add tmp(1)
    Next
    '--------------------------------------------------
    
    Set ci = New CIntellisenseItem
    ci.objName = "globals"
    ci.Description = desc("globals")
    ci.path = App.path & "\userlib.js"
    Erase a
    push a, "h(x)*shortcut to ida.intToHex"
    push a, "t(x)*shortcut to ida.t(x)"
    push a, "d(x)*shortcut to list1.AddItem(x)"
    push a, "alert(x)*shortcut to ida.alert(x)"
    intellisense.Add ci, ci.objName
    
    For Each X In a
        tmp = Split(X, "*")
        ci.methods.Add tmp(0)
        ci.comments.Add tmp(1)
    Next
    '--------------------------------------------------
    
    Set ci_fso = New CIntellisenseItem
    ci_fso.objName = "fso"
    ci_fso.Description = desc("fso")
    Erase a
    push a, "Function ReadFile(filename) As Variant*"
    push a, "Function readFileHex(filename) As Variant*"
    push a, "Sub WriteFile(path As String, it As Variant)*"
    push a, "Sub AppendFile(path, it)*"
    push a, "Function FileExists(path As String) As Boolean*"
    push a, "Function DeleteFile(fpath As String) As Boolean*"
    push a, "Function OpenFileDialog() As String*"
    push a, "Function SaveFileDialog() As String*"
    push a, "Function expandPath(path) As String*supports %sp% for scriptPath, %desktop%, and env vars"
    intellisense.Add ci_fso, ci_fso.objName
    
    For Each X In a
        tmp = Split(X, "*")
        ci_fso.methods.Add tmp(0)
        ci_fso.comments.Add tmp(1)
    Next
    '--------------------------------------------------
    
    Set ci_fn = New CIntellisenseItem
    ci_fn.objName = "fn"
    ci_fn.Description = desc("fn")
    Erase a '"index name start end size xrefs refqty argsize tailqty labelqty frsize"
    push a, "property get index as long*"
    push a, "property get name as string*"
    push a, "property get start*"
    push a, "property get end*"
    push a, "property get size*"
    push a, "property get xrefs*"
    push a, "property get refqty*"
    push a, "property get argsize*"
    push a, "property get tailqty*"
    push a, "property get labelqty*"
    push a, "property get frsize*"
    intellisense.Add ci_fn, ci_fn.objName
    
    For Each X In a
        tmp = Split(X, "*")
        ci_fn.methods.Add tmp(0)
        ci_fn.comments.Add tmp(1)
    Next
    '--------------------------------------------------

    Set ci_sect = New CIntellisenseItem
    ci_sect.objName = "sect"
    ci_sect.Description = desc("sect")
    Erase a
    push a, "property get index as long*"
    push a, "property get name as string*"
    push a, "property get base*"
    push a, "property get size*"
    intellisense.Add ci_sect, ci_sect.objName
    
    For Each X In a
        tmp = Split(X, "*")
        ci_sect.methods.Add tmp(0)
        ci_sect.comments.Add tmp(1)
    Next
    '--------------------------------------------------

  

    Dim isIDAObj As Boolean
    
    For Each f In js
    
        isIDAObj = False
        dat = fso.ReadFile(f)
        protoEnd = InStr(dat, "*/")
        
        If protoEnd < 1 Then
            errors.Add "proto type block missing in js bindings for " & fso.FileNameFromPath(f)
        Else
            Set ci = New CIntellisenseItem
            ci.objName = fso.GetBaseName(f)
            If ci.objName = "TextBox" Then GoTo skipit 'only used internally for format js
            If ci.objName = "ida" Then isIDAObj = True
            
            ci.path = f
            intellisense.Add ci, ci.objName
            
            If keyExists(ci.objName, desc) Then ci.Description = desc(ci.objName) 'top level class descriptions
            
            dat = Mid(dat, 1, protoEnd - 1)
            dat = Replace(dat, vbTab, Empty)
            dat = Split(dat, vbCrLf)
            
            For Each d In dat
                d = Trim(d)
                If Len(d) > 0 And _
                    VBA.Left(d, 1) <> "/" And _
                    VBA.Left(d, 1) <> "#" And _
                    VBA.Left(d, 1) <> ";" _
                Then 'its not a comment line..
                    'Debug.Print "Parsing: " & d
                    If isIDAObj Then
                        'since ida is aliased as these others to break up intellisense, we hide the extra methods here for simplicity..
                        If Not ci_app.ContainsMethod(d) And Not ci_fso.ContainsMethod(d) Then
                            ci.methods.Add d
                            addComment ci, d, xtra_comments
                        Else
                            'Debug.Print "hiding from ida obj: " & d
                            'If InStr(d, "Message") > 0 Then Stop
                        End If
                    Else
                        ci.methods.Add d
                        addComment ci, d, xtra_comments
                    End If
                End If
            Next
skipit:
        End If
    Next
    
End Function

Function addComment(ci As CIntellisenseItem, proto, c As Collection) As String
    On Error Resume Next
    Dim k As String, cmt As String
    k = ci.ExtractName(proto)
    'If k = "getFunc" Then Stop
    cmt = c(k)
    If Err.Number = 0 Then
        ci.comments.Add cmt, k
    Else
        ci.comments.Add "", k
    End If
End Function

Function keyExists(ByVal t As String, c As Collection) As Boolean
    On Error GoTo hell
    Dim X
    
    If IsObject(c(t)) Then
        Set X = c(t)
    Else
        X = c(t)
    End If
    
    keyExists = True
Exit Function
hell:
End Function

Sub push(ary, Value) 'this modifies parent ary object
    On Error GoTo Init
    Dim X
       
    X = UBound(ary)
    ReDim Preserve ary(X + 1)
    
    If IsObject(Value) Then
        Set ary(X + 1) = Value
    Else
        ary(X + 1) = Value
    End If
    
    Exit Sub
Init:
    ReDim ary(0)
    If IsObject(Value) Then
        Set ary(0) = Value
    Else
        ary(0) = Value
    End If
End Sub


Public Sub lvColumnSort(ListViewControl As Object, Column As Object)
    On Error Resume Next
    Const lvwAscending As Long = 0
    Const lvwDescending As Long = 1
     
    With ListViewControl
       If .SortKey <> Column.Index - 1 Then
             .SortKey = Column.Index - 1
             .SortOrder = lvwAscending
       Else
             If .SortOrder = lvwAscending Then
              .SortOrder = lvwDescending
             Else
              .SortOrder = lvwAscending
             End If
       End If
       .Sorted = -1
    End With
End Sub

Sub FormPos(fform As Object, Optional andSize As Boolean = False, Optional save_mode As Boolean = False)
    
    On Error Resume Next
    
    Dim f, sz, i, ff, def
    f = Split(",Left,Top,Height,Width", ",")
    
    If fform.WindowState = vbMinimized Then Exit Sub
    If andSize = False Then sz = 2 Else sz = 4
    
    For i = 1 To sz
        If save_mode Then
            ff = CallByName(fform, f(i), VbGet)
            SaveSetting App.EXEName, fform.name & ".FormPos", f(i), ff
        Else
            def = CallByName(fform, f(i), VbGet)
            ff = GetSetting(App.EXEName, fform.name & ".FormPos", f(i), def)
            CallByName fform, f(i), VbLet, ff
        End If
    Next
    
End Sub










